/*
Cdric Taschereau 05 658 674
Francis Corriveau 06 800 198

IFT 630 Projet
*/

//classe qui implante un tri fusion

public class MergeSort extends GenericSorter {
	
	public MergeSort()
	{ }
	
	public String getName()
	{ return "Mergesort"; }
	
	public String getSorterType()
	{ return GenericSorter.MERGESORT; }
	
	//mthode mergesort
	public RidiculouslyComplexObject[] doSort(RidiculouslyComplexObject[] data, int nbThreads)
	{
		RidiculouslyComplexObject[] left, right;
		
		if (data.length > 1)
		{
			int middle = data.length / 2;
			left = new RidiculouslyComplexObject[middle];
			right = new RidiculouslyComplexObject[data.length - middle];
			
			for(int i = 0; i < middle; i++)
				left[i] = data[i];
			for(int i = middle; i < data.length; i++)
				right[i - middle] = data[i];
			
			SubArrays mySubArrays = new SubArrays(left, right);
			mySubArrays = sendToThreadAndSort(mySubArrays, nbThreads);
			
			data = merge(mySubArrays.left, mySubArrays.right);
		}
		
		return data;
	} 


	private RidiculouslyComplexObject[] merge(RidiculouslyComplexObject[] myleft, RidiculouslyComplexObject[] myright)
	{
		RidiculouslyComplexObject[] result = new RidiculouslyComplexObject[myleft.length + myright.length];
		int i = 0, j = 0, k = 0;	//les index des array
		
		while(i < myleft.length && j < myright.length)
		{
			if(myleft[i].isSmallerOrEqual(myright[j]))
			{
				result[k] = myleft[i];
				i++;
			}
			else
			{
				result[k] = myright[j];
				j++;
			}
			k++;
		}
		
		for(; i < myleft.length; i++)
		{
			result[k] = myleft[i];
			k++;
		}
		for(; j < myright.length; j++)
		{
			result[k] = myright[j];
			k++;
		}
			
		return result;
	}

}